package com.jiuqi.sql;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.jiuqi.sql.DBException;
import java.io.IOException;
import java.io.Reader;

public abstract class SQLScriptExcutor {
  private Reader reader;
  
  private boolean isIgnoreComment;
  
  private boolean isString;
  
  private boolean isBlockComment;
  
  private boolean isLineComment;
  
  private StringBuffer sql;
  
  private StringBuffer line;
  
  public SQLScriptExcutor(Reader sqlReader, boolean isIgnoreComment) {
    this.reader = sqlReader;
    this.isIgnoreComment = isIgnoreComment;
    this.sql = new StringBuffer();
    this.line = new StringBuffer();
  }
  
  public final void parse() throws IOException, DBException {
    int i;
    while ((i = this.reader.read()) != -1) {
      char c = (char)i;
      if (c == '\r' || c == '\n') {
        if (this.line.length() != 0) {
          this.sql.append(this.line.toString());
          this.sql.append("\r\n");
          this.line.setLength(0);
        } 
        this.isLineComment = false;
        continue;
      } 
      if (this.isLineComment)
        continue; 
      if (this.isBlockComment && this.isIgnoreComment) {
        if (c == '*') {
          i = this.reader.read();
          c = (char)i;
          if (c != -1 && 
            c == '/')
            this.isBlockComment = false; 
        } 
        continue;
      } 
      switch (c) {
        case '\'':
          this.line.append(c);
          if (!this.isBlockComment)
            this.isString = !this.isString; 
          continue;
        case '-':
          if (!this.isBlockComment && !this.isString) {
            i = this.reader.read();
            c = (char)i;
            if (c == '-') {
              this.isLineComment = true;
              continue;
            } 
            this.line.append('-').append(c);
            continue;
          } 
          this.line.append('-');
          continue;
        case '/':
          if (!this.isBlockComment && !this.isString) {
            i = this.reader.read();
            c = (char)i;
            if (i != -1) {
              if (c == '*') {
                this.isBlockComment = true;
                if (!this.isIgnoreComment)
                  this.line.append('/').append(c); 
                continue;
              } 
              this.line.append('/').append(c);
            } 
            continue;
          } 
          this.line.append('/');
          continue;
        case '*':
          if (this.isBlockComment) {
            c = (char)this.reader.read();
            if (c != -1) {
              if (c == '/')
                this.isBlockComment = false; 
              if (!this.isIgnoreComment)
                this.line.append('*').append(c); 
            } 
            continue;
          } 
          this.line.append('*');
          continue;
        case ';':
          if (!this.isBlockComment && !this.isString) {
            excute();
            continue;
          } 
          this.line.append(';');
          continue;
        case 'g':
          if (!this.isBlockComment && !this.isString) {
            i = this.reader.read();
            c = (char)i;
            if (c == 'O' || c == 'o') {
              i = this.reader.read();
              char nextChar = (char)i;
              if (nextChar == '\r' || nextChar == '\n') {
                excute();
                continue;
              } 
              this.line.append('g').append(c).append(nextChar);
              continue;
            } 
            this.line.append('g').append(c);
            continue;
          } 
          this.line.append('g');
          continue;
        case 'G':
          if (!this.isBlockComment && !this.isString) {
            i = this.reader.read();
            c = (char)i;
            if (c == 'O' || c == 'o') {
              i = this.reader.read();
              char nextChar = (char)i;
              if (nextChar == '\r' || nextChar == '\n') {
                excute();
                continue;
              } 
              this.line.append('G').append(c).append(nextChar);
              continue;
            } 
            this.line.append('G').append(c);
            continue;
          } 
          this.line.append('G');
          continue;
      } 
      this.line.append(c);
    } 
    excute();
  }
  
  public boolean isIgnoreComment() {
    return this.isIgnoreComment;
  }
  
  private void excute() throws DBException {
    this.sql.append(this.line.toString());
    if (this.sql.length() != 0)
      excuteSingleSql(this.sql.toString()); 
    this.line.setLength(0);
    this.sql.setLength(0);
  }
  
  protected abstract void excuteSingleSql(String paramString) throws DBException;
}
